import javax.swing.*;

public class LinearnaRegresija
{
  public static void main (String[] args)
  {
    // VNOS PODATKOV

    // vprašamo po velikosti (obeh) tabel in ju s pomočjo zanke napolnimo
    String vnos = JOptionPane.showInputDialog("Koliko parov podatkov lahko pričakujem?");
    int m = Integer.parseInt (vnos);

    double[] xkoord = new double[m];
    double[] ykoord = new double[m];
    double x = 0, y = 0;
    int i = 0;
    while (i < m){
      vnos = JOptionPane.showInputDialog("x" + (i + 1) + " =");
      x = Double.parseDouble (vnos);
      xkoord[i] = x;
      vnos = JOptionPane.showInputDialog("y" + (i + 1) + " =");
      y = Double.parseDouble (vnos);
      ykoord[i] = y;
      i++;
    }

    // ANALIZA PODATKOV
    // kličemo metodi za izračun strmine in koeficienta n
    String enacba = ("y = " + koefk(xkoord, ykoord) + " * x + " + "(" + koefn(xkoord, ykoord) + ")" );

    // IZPIS
    JOptionPane.showMessageDialog(null,"Enačba premice\n\n" + enacba);
  }

  // METODE

  // metoda, ki bo izračunala vsoto elementov v tabeli (vsotaElementov)
  public static double vsotaElementov(double[] tabela){
     int i = 0;
     double vsota = 0;
     while (i < tabela.length){
        vsota = vsota + tabela[i];
        i++;
    }
    return vsota;
  }

  // metoda, ki bo izračunala vsoto kvadratov elementov v tabeli (vsotaKvadratElementov)
  public static double vsotaKvadratElementov(double[] tabela){
     int i = 0;
     double vsota = 0;
     while (i < tabela.length){
        vsota = vsota + tabela[i] * tabela[i] ;
        i++;
    }
    return vsota;
  }

  // metoda, ki bo izračunala vsoto zmnožkov enakoležnih elementov dveh tabel (vsotaProduktTabel)
  public static double vsotaProduktTabel(double[] tab1, double[] tab2){
     int i = 0;
     double vsota = 0;
     int velTab = tab1.length;
     while (i < velTab){
        vsota = vsota + tab1[i] * tab2[i];
        i++;
    }
    return vsota;
  }

  // metoda za izračun strmine premice na dve decimalni mesti
  public static double koefk (double[] tab1, double[] tab2){
     double zgornjiIzraz = vsotaProduktTabel(tab1, tab2) - ((vsotaElementov(tab1)) * (vsotaElementov(tab2)) / tab1.length);
     double spodnjiIzraz = vsotaKvadratElementov(tab1) - vsotaElementov (tab1) * vsotaElementov (tab1) / tab1.length;
     double k =  zgornjiIzraz / spodnjiIzraz;
     k = ((int)(k * 100)) / 100.0;
     return k;
  }

  // metoda za izračun koeficienta n na dve decimalni mesti
  public static double koefn (double[] tab1, double[] tab2){
     double n = (vsotaElementov (tab2) - koefk(tab1, tab2) * vsotaElementov (tab1)) / tab1.length;
     n = ((int)(n * 100)) / 100.0;
     return n;
  }
}
